#!/bin/bash
set -e
set -o pipefail

ROOT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

init()
{
	status "installing dep"
	go get -v -u github.com/golang/dep/...
}


status() {
	echo ""
    echo "-- ${*} --"
    echo ""
}

dependencies()
{
	status "dependencies"
	cd ${ROOT_DIR}/src/foo
	dep ensure -v
	# In order to fix the error following error:
	# vet: /go/src/foo/bar/main.go:4:2: could not import github.com/Sirupsen/logrus (can't find import: foo/vendor/github.com/Sirupsen/logrus)
	# I need to uncomment the following line:
	#go get -v foo/bar
	cd ${ROOT_DIR}
}

vet()
{
	status "vet"
    go tool vet -all -v ${ROOT_DIR}/src/foo/bar
}

build()
{
	status "build"
    CGO_ENABLED=0 GOOS=linux \
        go install -v -a -installsuffix cgo foo/bar
}

init
dependencies
vet
build